program Fkfilt2

  use sep
  use ooio

  implicit none

  type(axis)                           :: ka, km, z
  complex, dimension(:,:), allocatable :: slice
  integer                              :: ia, im, iz
  real                                 :: sigma, epsilon, klim
  logical                              :: trialrun

  call sep_init()

  ka = readaxis(1)
  km = readaxis(2)
  z  = readaxis(3)

  call from_param('sigma',sigma)
  call from_param('epsilon',epsilon)
  call from_param('trialrun',trialrun)
  call sep_close()

  allocate(slice(ka%n,km%n))
  slices: do iz=1,z%n
     if(trialrun) then
        slice=1.
     else
        call sep_read(slice)
     end if

     do im=1,km%n
        km%v=km%o+(im-1)*km%d
        if(sigma*km%v>ka%o.and.sigma*km%v<ka%o+(ka%n-1)*ka%d) then
           klim=-sigma*abs(km%v)
           do ia=1,ka%n/2
              ka%v=ka%o+(ia-1)*ka%d
              if(ka%v<klim) slice(ia,im)=exp(-epsilon*(ka%v-klim)**2)*slice(ia,im)
           end do
           klim=-klim
           do ia=ka%n/2+1,ka%n 
              ka%v=ka%o+(ia-1)*ka%d
              if(ka%v>klim) slice(ia,im)=exp(-epsilon*(ka%v-klim)**2)*slice(ia,im)
           end do
        end if
     end do
     call sep_write(slice)
  end do slices
  deallocate(slice)
end program Fkfilt2
