program Resampl
! Doubles the sampling in offset. Needs offset=axis1
  use sep
  use ooi2
  use fft_data_mod2
  implicit none

  real   , dimension(:), allocatable :: f
  complex, dimension(:), allocatable :: s
  type(axis)                         :: h1, h2
  type(fft_type)                     :: rfft_1d_id1, rfft_1d_id2
  integer                            :: i, n2, n3

  call sep_init()

  h1   = readaxis(1,chk_even=.true.)
  h2%d = h1%d/2.
  h2%n = h1%n*2
  call writeaxis(h2,1,axisname='offset (km)')

  call from_history('n2', n2)
  call from_history('n3', n3)

  call sep_close()
  rfft_1d_id1 = init_rfft_1d(h1%n)
  rfft_1d_id2 = init_rfft_1d(h2%n)
  
  allocate(f(h2%n),s(h2%n/2+1))

  do i=1,n2*n3
     f=0.; s=0.
     call sep_read(f(1:h1%n))
     call rfft_1d_data(rfft_1d_id1,FFTW_REAL_TO_COMPLEX,h1%n,f(1:h1%n),s(1:h1%n/2+1))
     f=0.
     call rfft_1d_data(rfft_1d_id2,FFTW_COMPLEX_TO_REAL,h2%n,f,s)
     call sep_write(f)
  end do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  deallocate(f,s)
  call clean_rfft(rfft_1d_id1)
  call clean_rfft(rfft_1d_id2)
end program Resampl
