program Shift

  use sep
  use ooi2
  use fft_data_mod2
  implicit none

  real   , dimension(:), allocatable :: f, k_v
  complex, dimension(:), allocatable :: s
  real                               :: d
  type(axis)                         :: h, t, y, k
  type(fft_type)                     :: rfft_1d_id
  integer                            :: i, p, n

  call sep_init()
  call from_param('distance', d)
  call from_param('pad',p,0)

  h = readaxis(1)
  t = readaxis(2)
  y = readaxis(3)

  n = h%n+p
  if(mod(n,2)==1) call seperr('Choose another pad')

  k%n = n/2 + 1
  k%d = 1./(n*h%d)
  k%o = 0.

  h%o = h%o - d
  call writeaxis(h,1,axisname='offset')
  call sep_close()
  rfft_1d_id = init_rfft_1d(n)
  allocate(f(n),s(k%n),k_v(k%n))

  do i=1,k%n
     k_v=k%o+(i-1)*k%d
  end do

  do i=1,t%n*y%n
     f=0.
     call sep_read(f(1:h%n))
     call rfft_1d_data(rfft_1d_id,FFTW_REAL_TO_COMPLEX,n,f,s)
     s = s * exp(cmplx(0., -6.28318530717959 * k_v * d))
     call rfft_1d_data(rfft_1d_id,FFTW_COMPLEX_TO_REAL,n,f,s)
     call sep_write(f(1:h%n))
  end do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  deallocate(f,s,k_v)
  call clean_rfft(rfft_1d_id)
end program Shift
